Attribute VB_Name = "modParseStats"
Option Explicit
Private Function GetCharacterName(ByVal Statstring As String, ByVal start As Byte, ByRef cName As String) As Byte
    On Error GoTo Erred
    cName = Mid$(Statstring, start, InStr(start, Statstring, ",") - start)
    GetCharacterName = InStr(start, Statstring, ",") + 1
Exit Function
Erred:
    ErrorHandler "Parse", "GetCharName"
    Resume Next
End Function
Private Function GetServer(ByVal Statstring As String, ByRef Server As String) As Byte
    On Error GoTo Erred
    Server = Mid$(Statstring, 5, InStr(5, Statstring, ",") - 5)
    GetServer = InStr(5, Statstring, ",") + 1
Exit Function
Erred:
    ErrorHandler "Parse", "GetServer"
    Resume Next
End Function
Private Sub MakeArray(ByVal Text As String, ByRef nArray() As Byte)
Dim I As Long
    On Error GoTo Erred
    ReDim nArray(0) As Byte
    For I = 0 To Len(Text) - 1
        nArray(I) = CByte(Asc(Mid$(Text, I + 1, 1)))
        If I <> Len(Text) Then
            ReDim Preserve nArray(0 To UBound(nArray) + 1) As Byte
        End If
    Next I
Exit Sub
Erred:
    ErrorHandler "Parse", "MakeArray"
    Resume Next
End Sub
Public Function ParseD2Stats(ByVal stats As String)
Dim d2classes(0 To 7) As String
Dim statbuf           As String
Dim P()               As Byte
Dim Server            As String
Dim Name              As String
Dim sLen              As Byte
Dim CharClass         As Byte
Dim Female            As Boolean
Dim CharLevel         As Long
Dim Hardcore          As Boolean
Dim Dead              As Boolean
Dim Ladder            As Boolean
Dim Expansion         As Boolean
Dim D2Act             As String
Dim D2Title           As Integer
    On Error GoTo Erred
    d2classes(0) = "Amazon"
    d2classes(1) = "Sorceress"
    d2classes(2) = "Necromancer"
    d2classes(3) = "Paladin"
    d2classes(4) = "Barbarian"
    d2classes(5) = "Druid"
    d2classes(6) = "Assassin"
    d2classes(7) = "unknown class"
    If Len(stats) > 4 Then
        sLen = GetServer(stats, Server)
        sLen = GetCharacterName(stats, sLen, Name)
        MakeArray Mid$(stats, sLen), P()
    End If
    If Left$(stats, 4) = "VD2D" Then
        statbuf = statbuf & "Diablo II: "
    Else
        statbuf = statbuf & "Diablo II Lord of Destruction: "
    End If
    If Len(stats) = 4 Then
        statbuf = statbuf & "Open Character"
    Else
        CharClass = P(13) - 1
        If (CharClass < 0) Or (CharClass > 6) Then
            CharClass = 7
        End If
        If (CharClass = 0) Or (CharClass = 1) Or (CharClass = 6) Then
            Female = True
        End If
        CharLevel = P(25)
        Hardcore = P(26) And &H4
        Dead = P(26) And &H8
        Expansion = P(26) And &H20
        Ladder = Not (P(30) = 255)
        If Left$(stats, 4) = "PX2D" And (P(26) And &H20) Then
            Select Case P(27)
                Case &H80
                    D2Act = "1 (Normal)"
                    D2Title = 0
                Case &H82
                    D2Act = "2 (Normal)"
                    D2Title = 0
                Case &H84
                    D2Act = "3 (Normal)"
                    D2Title = 0
                Case &H86
                    D2Act = "4/5 (Normal)"
                    D2Title = 0
                Case &H88
                    D2Act = "5 (Normal)"
                    D2Title = 0
                Case &H8A
                    D2Act = "1 (Nightmare)"
                    D2Title = 1
                Case &H8C
                    D2Act = "2 (Nightmare)"
                    D2Title = 1
                Case &H8E
                    D2Act = "3 (Nightmare)"
                    D2Title = 1
                Case &H90
                    D2Act = "4/5 (Nightmare)"
                    D2Title = 1
                Case &H92
                    D2Act = "5 (Nightmare)"
                    D2Title = 1
                Case &H94
                    D2Act = "1 (Hell)"
                    D2Title = 2
                Case &H96
                    D2Act = "2 (Hell)"
                    D2Title = 2
                Case &H98
                    D2Act = "3 (Hell)"
                    D2Title = 2
                Case &H9A
                    D2Act = "4/5 (Hell)"
                    D2Title = 2
                Case &H9C
                    D2Act = "5 (Hell)"
                    D2Title = 2
                Case &H9E
                    D2Act = vbNullString
                    D2Title = 3
                Case Else
                    D2Act = vbNullString
                    D2Title = P(27)
                End Select
            Select Case D2Title
                Case &H0
                    'Nothing
                Case &H1
                    If Hardcore Then
                        statbuf = statbuf & "Destroyer "
                    Else
                        statbuf = statbuf & "Slayer "
                    End If
                Case &H2
                    If Hardcore Then
                        statbuf = statbuf & "Conquerer "
                    Else
                        statbuf = statbuf & "Champion "
                    End If
                Case &H3
                    If Hardcore Then
                        statbuf = statbuf & "Guardian "
                    Else
                        If Not Female Then
                            statbuf = statbuf & "Patriarch "
                        Else
                            statbuf = statbuf & "Matriarch "
                        End If
                    End If
                Case Else
                    statbuf = statbuf & "Unknown (0x" & Hex$(P(27)) & ")"
            End Select
        Else
            Select Case P(27)
                Case &H80
                    D2Act = "1 (Normal)"
                    D2Title = 0
                Case &H82
                    D2Act = "2 (Normal)"
                    D2Title = 0
                Case &H84
                    D2Act = "3 (Normal)"
                    D2Title = 0
                Case &H86
                    D2Act = "4 (Normal)"
                    D2Title = 0
                Case &H88
                    D2Act = "1 (Nightmare)"
                    D2Title = 1
                Case &H8A
                    D2Act = "2 (Nightmare)"
                    D2Title = 1
                Case &H8C
                    D2Act = "3 (Nightmare)"
                    D2Title = 1
                Case &H8E
                    D2Act = "4 (Nightmare)"
                    D2Title = 1
                Case &H90
                    D2Act = "1 (Hell)"
                    D2Title = 2
                Case &H92
                    D2Act = "2 (Hell)"
                    D2Title = 2
                Case &H94
                    D2Act = "3 (Hell)"
                    D2Title = 2
                Case &H96
                    D2Act = "4 (Hell)"
                    D2Title = 2
                Case &H98
                    D2Act = vbNullString
                    D2Title = 3
                Case Else
                    D2Act = vbNullString
                    D2Title = 0
            End Select
            Select Case D2Title
                Case &H0
                    'Nothing
                Case &H1
                    If Not Female Then
                        If Hardcore Then
                            statbuf = statbuf & "Count "
                        Else
                            statbuf = statbuf & "Sir "
                        End If
                    Else
                        If Hardcore Then
                            statbuf = statbuf & "Countess "
                        Else
                            statbuf = statbuf & "Dame "
                        End If
                    End If
                Case &H2
                    If Not Female Then
                        If Hardcore Then
                            statbuf = statbuf & "Duke "
                        Else
                            statbuf = statbuf & "Lord "
                        End If
                    Else
                        If Hardcore Then
                            statbuf = statbuf & "Duchess "
                        Else
                            statbuf = statbuf & "Lady "
                        End If
                    End If
                Case &H3
                    If Not Female Then
                        If Hardcore Then
                            statbuf = statbuf & "King "
                        Else
                            statbuf = statbuf & "Baron "
                        End If
                    Else
                        If Hardcore Then
                            statbuf = statbuf & "Queen "
                        Else
                            statbuf = statbuf & "Baroness "
                        End If
                    End If
                Case Else
                    statbuf = statbuf & "Unknown (0x" & Hex$(P(27)) & ")"
            End Select
        End If
        sprintf statbuf, "%s, a ", Name
        If Hardcore Then
            If Dead Then
                statbuf = statbuf & "dead hardcore "
            Else
                statbuf = statbuf & "hardcore "
            End If
        End If
        sprintf statbuf, "level %s ", CharLevel
        If Ladder Then statbuf = statbuf & "ladder "
        If LenB(D2Act) > 0 Then
            If Expansion Then
                sprintf statbuf, "%s in act %s on realm %s (Expansion)", d2classes(CharClass), D2Act, Server
            Else
                sprintf statbuf, "%s in act %s on realm %s", d2classes(CharClass), D2Act, Server
            End If
        Else
            If Expansion Then
                sprintf statbuf, "%s on realm %s (Expansion)", d2classes(CharClass), Server
            Else
                sprintf statbuf, "%s on realm %s", d2classes(CharClass), Server
            End If
        End If
    End If
    ParseD2Stats = statbuf
Exit Function
Erred:
    ErrorHandler "Parse", "ParseD2Stats [" & stats & "]"
    Resume Next
End Function
Public Function ParseStatString(ByVal Statstring As String) As String
Dim OutBuf    As String
Dim Values()  As String
Dim cType     As String
Dim ClassName As String
Dim ClassLev  As Long
Dim I         As Integer
    On Error GoTo Erred
    Select Case StrReverse(Left$(Statstring, 4))
        Case "DRTL"
            Values() = Split(Mid$(Statstring, 6), " ")
            If UBound(Values) <> 8 Then
                If Statstring = "LTRD" Then
                    OutBuf = OutBuf & "a Diablo bot"
                Else
                    OutBuf = OutBuf & "an illegal Diablo character: [ " & Statstring & " ]"
                End If
            Else
                Select Case Values(1)
                    Case &H0
                        cType = "Warrior"
                    Case &H1
                        cType = "Rogue"
                    Case &H2
                        cType = "Sorcerer"
                    Case Else
                        cType = Values(1)
                End Select
                sprintf OutBuf, "Diablo: Level %s %s with %s dot" & IIf(Values(2) <> "1", "s", "") & ", %s strength, %s magic, %s dexterity, %s vitality, %s gold", Values(0), cType, Values(2), Values(3), Values(4), Values(5), Values(6), Values(7)
            End If
        Case "DSHR"
            Values() = Split(Mid$(Statstring, 6), " ")
            If UBound(Values) <> 8 Then
                If Statstring = "RHSD" Then
                    OutBuf = OutBuf & "a Diablo Shareware bot"
                Else
                    OutBuf = OutBuf & "an illegal Diablo Shareware Character: [ " & Statstring & " ]"
                End If
            Else
                Select Case Values(1)
                    Case &H0
                        cType = "Warrior"
                    Case &H1
                        cType = "Rogue"
                    Case &H2
                        cType = "Sorcerer"
                    Case Else
                        cType = Values(1)
                End Select
                sprintf OutBuf, "Diablo Shareware: Level %s %s with %s dot" & IIf(Values(2) <> "1", "s", "") & ", %s strength, %s magic, %s dexterity, %s vitality, %s gold", Values(0), cType, Values(2), Values(3), Values(4), Values(5), Values(6), Values(7)
            End If
        Case "D2DV"
            OutBuf = OutBuf & ParseD2Stats(Statstring)
        Case "D2XP"
            OutBuf = OutBuf & ParseD2Stats(Statstring)
        Case "STAR"
            Values() = Split(Mid$(Statstring, 6), " ")
            If UBound(Values) <> 8 Then
                sprintf OutBuf, "a Starcraft %sbot", IIf((Values(3) = 1), "(spawn) ", vbNullString)
            Else
                If Values(0) > 0 Then
                    If Values(1) > 0 Then
                        sprintf OutBuf, "Starcraft%s: %s normal game win" & IIf(Values(2) <> "1", "s", "") & ", with a rating of %s and a rank of %s on the ladder", IIf((Values(3) = 1), " (spawn) ", vbNullString), Values(2), Values(0), Values(1)
                    Else
                        sprintf OutBuf, "Starcraft%s: %s normal game win" & IIf(Values(2) <> "1", "s", "") & ", with a rating of %s on the ladder", IIf((Values(3) = 1), " (spawn) ", vbNullString), Values(2), Values(0)
                    End If
                Else
                    sprintf OutBuf, "Starcraft%s: %s normal game win" & IIf(Values(2) <> "1", "s", ""), IIf((Values(3) = 1), " (spawn) ", vbNullString), Values(2)
                End If
            End If
        Case "SSHR"
            OutBuf = OutBuf & "Starcraft Shareware"
        Case "JSTR"
            Values() = Split(Mid$(Statstring, 6), " ")
            If UBound(Values) <> 8 Then
                sprintf OutBuf, "a Japanese Starcraft %sbot", IIf((Values(3) = 1), "(spawn) ", vbNullString)
            Else
                If Values(0) > 0 Then
                    If Values(1) > 0 Then
                        sprintf OutBuf, "Japanese Starcraft%s: %s normal game win" & IIf(Values(2) <> "1", "s", "") & ", with a rating of %s and a rank of %s on the ladder", IIf((Values(3) = 1), " (spawn) ", vbNullString), Values(2), Values(0), Values(1)
                    Else
                        sprintf OutBuf, "Japanese Starcraft%s: %s normal game win" & IIf(Values(2) <> "1", "s", "") & ", with a rating of %s on the ladder", IIf((Values(3) = 1), " (spawn) ", vbNullString), Values(2), Values(0)
                    End If
                Else
                    sprintf OutBuf, "Japanese Starcraft%s: %s normal game win" & IIf(Values(2) <> "1", "s", "") & "", IIf((Values(3) = 1), " (spawn) ", vbNullString), Values(2)
                End If
            End If
        Case "SEXP"
            Values() = Split(Mid$(Statstring, 6), " ")
            If UBound(Values) <> 8 Then
                sprintf OutBuf, "a Starcraft Brood War %sbot", IIf((Values(3) = 1), "(spawn) ", vbNullString)
            Else
                If Values(0) > 0 Then
                    If Values(1) > 0 Then
                        sprintf OutBuf, "Starcraft Brood War%s: %s normal game win" & IIf(Values(2) <> "1", "s", "") & ", with a rating of %s and a rank of %s on the ladder", IIf((Values(3) = 1), " (spawn) ", vbNullString), Values(2), Values(0), Values(1)
                    Else
                        sprintf OutBuf, "Starcraft Brood War%s: %s normal game win" & IIf(Values(2) <> "1", "s", "") & ", with a rating of %s on the ladder", IIf((Values(3) = 1), " (spawn) ", vbNullString), Values(2), Values(0)
                    End If
                Else
                    sprintf OutBuf, "Starcraft Brood War%s: %s normal game win" & IIf(Values(2) <> "1", "s", "") & "", IIf((Values(3) = 1), " (spawn) ", vbNullString), Values(2)
                End If
            End If
        Case "W2BN"
            Values() = Split(Mid$(Statstring, 6), " ")
            If UBound(Values) <> 8 Then
                sprintf OutBuf, "a Warcraft II %sbot", IIf((Values(3) = 1), " (spawn) ", vbNullString)
            Else
                If Values(0) > 0 Then
                    If Values(1) > 0 Then
                        If Values(6) > 0 Then
                            If Values(7) > 0 Then
                                sprintf OutBuf, "Warcraft II%s: %s normal game win" & IIf(Values(2) <> "1", "s", "") & ", with a rating of %s and a rank of %s on the ladder, a rating of %s and a rank of %s on the IronMan Ladder", IIf((Values(3) = 1), " (spawn) ", vbNullString), Values(2), Values(0), Values(1), Values(6), Values(7)
                            Else
                                sprintf OutBuf, "Warcraft II%s: %s normal game win" & IIf(Values(2) <> "1", "s", "") & ", with a rating of %s and a rank of %s on the ladder, a rating of %s on the IronMan Ladder", IIf((Values(3) = 1), " (spawn) ", vbNullString), Values(2), Values(0), Values(1), Values(6)
                            End If
                        Else
                            sprintf OutBuf, "Warcraft II%s: %s normal game win" & IIf(Values(2) <> "1", "s", "") & ", with a rating of %s and a rank of %s on the ladder", IIf((Values(3) = 1), " (spawn) ", vbNullString), Values(2), Values(0), Values(1)
                        End If
                    Else
                        If Values(6) > 0 Then
                            If Values(7) > 0 Then
                                sprintf OutBuf, "Warcraft II%s: %s normal game win" & IIf(Values(2) <> "1", "s", "") & ", with a rating of %s on the ladder, a rating of %s and a rank of %s on the IronMan Ladder", IIf((Values(3) = 1), " (spawn) ", vbNullString), Values(2), Values(0), Values(6), Values(7)
                            Else
                                sprintf OutBuf, "Warcraft II%s: %s normal game win" & IIf(Values(2) <> "1", "s", "") & ", with a rating of %s on the ladder, a rating of %s on the IronMan Ladder", IIf((Values(3) = 1), " (spawn) ", vbNullString), Values(2), Values(0), Values(6)
                            End If
                        Else
                            sprintf OutBuf, "Warcraft II%s: %s normal game win" & IIf(Values(2) <> "1", "s", "") & ", with a rating of %s on the ladder", IIf((Values(3) = 1), " (spawn) ", vbNullString), Values(2), Values(0)
                        End If
                    End If
                Else
                    If Values(6) > 0 Then
                        If Values(7) > 0 Then
                            sprintf OutBuf, "Warcraft II%s: %s normal game win" & IIf(Values(2) <> "1", "s", "") & ", with a rating of %s and a rank of %s on the IronMan ladder", IIf((Values(3) = 1), " (spawn) ", vbNullString), Values(2), Values(6), Values(7)
                        Else
                            sprintf OutBuf, "Warcraft II%s: %s normal game win" & IIf(Values(2) <> "1", "s", "") & ", with a rating of %s on the IronMan ladder", IIf((Values(3) = 1), " (spawn) ", vbNullString), Values(2), Values(6)
                        End If
                    Else
                        sprintf OutBuf, "Warcraft II%s: %s normal game win" & IIf(Values(2) <> "1", "s", "") & "", IIf((Values(3) = 1), " (spawn) ", vbNullString), Values(2)
                    End If
                End If
            End If
        Case "WAR3"
            If Len(Statstring) > 10 Then
                Statstring = Statstring & " "
                Values() = Split(Mid$(Statstring, 5), " ")
                For I = LBound(Values) To UBound(Values)
                    Values(I) = StrReverse(Values(I))
                Next I
                ClassName = Mid$(Values(1), 3, 1)
                ClassLev = CLng(Right$(Values(1), 1))
                Values(2) = StrReverse(Values(2))
                Select Case ClassName
                    Case "H"
                        Select Case ClassLev
                            Case &H1
                                cType = "Peon"
                            Case &H2
                                cType = "Human Footman (25 wins)"
                            Case &H3
                                cType = "Human Knight (250 wins)"
                            Case &H4
                                cType = "Human Archmage (500 wins)"
                            Case &H5
                                cType = "Human Medivh (1500 wins)"
                            Case Else
                                cType = "Human Unknown [ " & ClassLev & " ]"
                        End Select
                    Case "O"
                        Select Case ClassLev
                            Case &H1
                                cType = "Peon"
                            Case &H2
                                cType = "Orc Grunt (25 wins)"
                            Case &H3
                                cType = "Orc Tauren (250 wins)"
                            Case &H4
                                cType = "Orc Far Seer (500 wins)"
                            Case &H5
                                cType = "Orc Thrall (1500 wins)"
                            Case Else
                                cType = "Orc Unknown [ " & ClassLev & " ]"
                        End Select
                    Case "N"
                        Select Case ClassLev
                            Case &H1
                                cType = "Peon"
                            Case &H2
                                cType = "Night Elf Archer (25 wins)"
                            Case &H3
                                cType = "Night Elf Druid of the Claw (250 wins)"
                            Case &H4
                                cType = "Night Elf Priestess of the Moon (500 wins)"
                            Case &H5
                                cType = "Night Elf Furion Stormrage (1500 wins)"
                            Case Else
                                cType = "Night Elf Unknown [ " & ClassLev & " ]"
                        End Select
                    Case "U"
                        Select Case ClassLev
                            Case &H1
                                cType = "Peon"
                            Case &H2
                                cType = "Undead Ghoul (25 wins)"
                            Case &H3
                                cType = "Undead Abomination (250 wins)"
                            Case &H4
                                cType = "Undead Lich (500 wins)"
                            Case &H5
                                cType = "Undead Tichondrius (1500 wins)"
                            Case Else
                                cType = "Undead Unknown [ " & ClassLev & " ]"
                        End Select
                    Case "R"
                        Select Case ClassLev
                            Case &H1
                                cType = "Peon"
                            Case &H2
                                cType = "Random Green Dragon Whelp (25 wins)"
                            Case &H3
                                cType = "Random Blue Dragon (250 wins)"
                            Case &H4
                                cType = "Random Red Dragon (500 wins)"
                            Case &H5
                                cType = "Random Deathwing (1500 wins)"
                            Case Else
                                cType = "Random Unknown [ " & ClassLev & " ]"
                        End Select
                    Case Else
                        cType = "Unknown [ " & ClassName & ", " & ClassLev & " ]"
                End Select
                If LenB(Values(3)) > 0 Then
                    sprintf OutBuf, "Warcraft III Reign of Chaos: Level %s, with %s as icon, and in clan %s", Values(2), cType, Values(3)
                Else
                    sprintf OutBuf, "Warcraft III Reign of Chaos: Level %s, with %s as icon", Values(2), cType
                End If
            Else
                OutBuf = OutBuf & "Warcraft III Reign of Chaos [ Not Parsed: " & Statstring & " ]"
            End If
        Case "W3XP"
            If Len(Statstring) > 10 Then
                Statstring = Statstring & " "
                Values() = Split(Mid$(Statstring, 5), " ")
                For I = LBound(Values) To UBound(Values)
                    Values(I) = StrReverse(Values(I))
                Next I
                ClassName = Mid$(Values(1), 3, 1)
                ClassLev = CLng(Right$(Values(1), 1))
                Values(2) = StrReverse(Values(2))
                Select Case ClassName
                    Case "H"
                        Select Case ClassLev
                            Case &H1
                                cType = "Peon"
                            Case &H2
                                cType = "Human Rifleman (25 wins)"
                            Case &H3
                                cType = "Human Sorceress (150 wins)"
                            Case &H4
                                cType = "Human Spellbreaker (350 wins)"
                            Case &H5
                                cType = "Human Blood Mage (750 wins)"
                            Case &H6
                                cType = "Human Jaina (1500 wins)"
                            Case Else
                                cType = "Human Unknown [ " & ClassLev & " ]"
                        End Select
                    Case "O"
                        Select Case ClassLev
                            Case &H1
                                cType = "Peon"
                            Case &H2
                                cType = "Orc Troll Headhunter (25 wins)"
                            Case &H3
                                cType = "Orc Shaman (150 wins)"
                            Case &H4
                                cType = "Orc Spirit Walker (350 wins)"
                            Case &H5
                                cType = "Orc Shadow Hunter (750 wins)"
                            Case &H6
                                cType = "Orc Rexxar (1500 wins)"
                            Case Else
                                cType = "Orc Unknown [ " & ClassLev & " ]"
                        End Select
                    Case "N"
                        Select Case ClassLev
                            Case &H1
                                cType = "Peon"
                            Case &H2
                                cType = "Night Elf Huntress (25 wins)"
                            Case &H3
                                cType = "Night Elf Druid of the Talon (150 wins)"
                            Case &H4
                                cType = "Night Elf Dryad (350 wins)"
                            Case &H5
                                cType = "Night Elf Keeper of the Grove (750 wins)"
                            Case &H6
                                cType = "Night Elf Maiev (1500 wins)"
                            Case Else
                                cType = "Night Elf Unknown [ " & ClassLev & " ]"
                        End Select
                    Case "U"
                        Select Case ClassLev
                            Case &H1
                                cType = "Peon"
                            Case &H2
                                cType = "Undead Crypt Fiend (25 wins)"
                            Case &H3
                                cType = "Undead Banshee (150 wins)"
                            Case &H4
                                cType = "Undead Destroyer (350 wins)"
                            Case &H5
                                cType = "Undead Crypt Lord (750 wins)"
                            Case &H6
                                cType = "Undead Sylvanas (1500 wins)"
                            Case Else
                                cType = "Undead Unknown [ " & ClassLev & " ]"
                        End Select
                    Case "R"
                        Select Case ClassLev
                            Case &H1
                                cType = "Peon"
                            Case &H2
                                cType = "Random Myrmidon (25 wins)"
                            Case &H3
                                cType = "Random Siren (150 wins)"
                            Case &H4
                                cType = "Random Dragon Turtle (350 wins)"
                            Case &H5
                                cType = "Random Sea Witch (750 wins)"
                            Case &H6
                                cType = "Random Illidan (1500 wins)"
                            Case Else
                                cType = "Random Unknown [ " & ClassLev & " ]"
                        End Select
                    Case "D"
                        Select Case ClassLev
                            Case &H1
                                cType = "Peon"
                            Case &H2
                                cType = "Tournament Felguard (10 wins)"
                            Case &H3
                                cType = "Tournament Infernal (75 wins)"
                            Case &H4
                                cType = "Tournament Doomguard (150 wins)"
                            Case &H5
                                cType = "Tournament Pit Lord (250 wins)"
                            Case &H6
                                cType = "Tournament Archimonde (500 wins)"
                            Case Else
                                cType = "Tournament Unknown [ " & ClassLev & " ]"
                        End Select
                    Case Else
                        cType = "Unknown [ " & ClassName & ", " & ClassLev & " ]"
                End Select
                If LenB(Values(3)) > 0 Then
                    sprintf OutBuf, "Warcraft III the Frozen Throne: Level %s, with %s as icon, and in clan %s", Values(2), cType, Values(3)
                Else
                    sprintf OutBuf, "Warcraft III the Frozen Throne: Level %s, with %s as icon", Values(2), cType
                End If
            Else
                OutBuf = OutBuf & "Warcraft III the Frozen Throne [ Not Parsed: " & Statstring & " ]"
            End If
        Case "CHAT"
            OutBuf = OutBuf & "a Chat bot"
        Case Else
            OutBuf = OutBuf & "an unknown client [ " & Statstring & " ]"
    End Select
    ParseStatString = OutBuf
Exit Function
Erred:
    ErrorHandler "Parse", "ParseStatString [" & Statstring & "]"
    Resume Next
End Function
Public Sub sprintf(ByRef Source As String, ByVal nText As String, Optional ByVal A As Variant, Optional ByVal B As Variant, Optional ByVal C As Variant, Optional ByVal D As Variant, Optional ByVal E As Variant, Optional ByVal f As Variant, Optional ByVal G As Variant, Optional ByVal h As Variant)
Dim I As Byte
    On Error GoTo Erred
    nText = Replace$(nText, "%S", "%s")
    I = 0
    Do While InStr(1, nText, "%s") > 0
        Select Case I
            Case 0
                If IsEmpty(A) Then Exit Do
                nText = Replace$(nText, "%s", A, 1, 1)
            Case 1
                If IsEmpty(B) Then Exit Do
                nText = Replace$(nText, "%s", B, 1, 1)
            Case 2
                If IsEmpty(C) Then Exit Do
                nText = Replace$(nText, "%s", C, 1, 1)
            Case 3
                If IsEmpty(D) Then Exit Do
                nText = Replace$(nText, "%s", D, 1, 1)
            Case 4
                If IsEmpty(E) Then Exit Do
                nText = Replace$(nText, "%s", E, 1, 1)
            Case 5
                If IsEmpty(f) Then Exit Do
                nText = Replace$(nText, "%s", f, 1, 1)
            Case 6
                If IsEmpty(G) Then Exit Do
                nText = Replace$(nText, "%s", G, 1, 1)
            Case 7
                If IsEmpty(h) Then Exit Do
                nText = Replace$(nText, "%s", h, 1, 1)
        End Select
        I = I + 1
    Loop
    Source = Source & nText
Exit Sub
Erred:
    ErrorHandler "Parse", "sprintf"
    Resume Next
End Sub
Public Function ParseMapStats(ByVal strStats As String, Optional ByVal Shorten As Boolean = False) As String
Dim strMapSize   As String
Dim strGameType  As String
Dim strGameSpeed As String
Dim strPenalty   As String
Dim strIcon      As String
Dim strCreator   As String
Dim strMapName   As String
Dim varSplit     As Variant
    On Error GoTo Erred
    varSplit = Split(strStats, ",")
    If LenB(varSplit(1)) > 0 Then
        strMapSize = "Size: " & (Mid$(varSplit(1), 1, 1) * 32) & "x" & (Mid$(varSplit(1), 2, 1) * 32)
    Else
        strMapSize = "Size: Default"
    End If
    strGameSpeed = "Speed: " & GameSpeed(varSplit(3))
    strIcon = "Icon: " & MapIcon(varSplit(4))
    strGameType = "Type: " & GameType(varSplit(5))
    strPenalty = "Rules: " & GamePenalty(varSplit(7))
    If UBound(varSplit) >= 11 Then
        If LenB(varSplit(11)) > 0 Then
            strCreator = "Creator: " & Left$(varSplit(11), InStr(1, varSplit(11), vbCr) - 1)
            strMapName = "Map Name: " & Mid$(varSplit(11), InStr(1, varSplit(11), vbCr) + 1)
        Else
            strCreator = "Creator: [UNKNOWN]"
            strMapName = "Map Name: [UNKNOWN]"
        End If
    ElseIf UBound(varSplit) >= 10 Then
        If LenB(varSplit(10)) > 0 Then
            strCreator = "Creator: " & Left$(varSplit(10), InStr(1, varSplit(10), vbCr) - 1)
            strMapName = "Map Name: " & Mid$(varSplit(10), InStr(1, varSplit(10), vbCr) + 1)
        Else
            strCreator = "Creator: [UNKNOWN]"
            strMapName = "Map Name: [UNKNOWN]"
        End If
    ElseIf UBound(varSplit) >= 9 Then
        If LenB(varSplit(9)) > 0 Then
            strCreator = "Creator: " & Left$(varSplit(9), InStr(1, varSplit(9), vbCr) - 1)
            strMapName = "Map Name: " & Mid$(varSplit(9), InStr(1, varSplit(9), vbCr) + 1)
        Else
            strCreator = "Creator: [UNKNOWN]"
            strMapName = "Map Name: [UNKNOWN]"
        End If
    End If
    strMapName = Replace$(strMapName, vbCr, "")
    strMapName = Replace$(strMapName, vbLf, "")
    If Shorten Then
        ParseMapStats = strCreator & vbCrLf & strMapName
    Else
        ParseMapStats = strCreator & vbCrLf & strMapName & vbCrLf & strMapSize & vbCrLf & strGameSpeed & vbCrLf & strIcon & strGameType & vbCrLf & strPenalty
    End If
    Exit Function
Erred:
    ErrorHandler "Parse", "ParseMapStats"
    Resume Next
End Function
Private Function MapIcon(ByVal strCase As String) As String
    On Error GoTo Erred
    Select Case strCase
        Case "1"
            MapIcon = "Blizzard Approved"
        Case "2"
            MapIcon = "Ladder"
        Case "3"
            MapIcon = "GF"
        Case "4"
            MapIcon = "KBK"
        Case Else
            MapIcon = "None"
    End Select
    Exit Function
Erred:
    ErrorHandler "Parse", "MapIcon"
    Resume Next
End Function
Private Function GamePenalty(ByVal strCase As String) As String
    On Error GoTo Erred
    Select Case strCase
        Case "2"
            GamePenalty = "Dissconnect is a Loss"
        Case "4"
            GamePenalty = "1 Team Victory only"
        Case Else
            GamePenalty = "No rules"
    End Select
    Exit Function
Erred:
    ErrorHandler "Parse", "GamePenalty"
    Resume Next
End Function
Private Function GameSpeed(ByVal strCase As String) As String
    On Error GoTo Erred
    Select Case strCase
        Case "0"
            GameSpeed = "Slowest"
        Case "1"
            GameSpeed = "Slower"
        Case "2"
            GameSpeed = "Slow"
        Case "3"
            GameSpeed = "Normal"
        Case "4"
            GameSpeed = "Fast"
        Case "5"
            GameSpeed = "Faster"
        Case "6"
            GameSpeed = "Fastest"
        Case Else
            GameSpeed = "Default"
    End Select
    Exit Function
Erred:
    ErrorHandler "Parse", "GameSpeed"
    Resume Next
End Function
Private Function GameType(ByVal strCase As String) As String
    On Error GoTo Erred
    Select Case strCase
        Case "2"
            GameType = "Melee"
        Case "3"
            GameType = "Free For All"
        Case "4"
            GameType = "One on One"
        Case "5"
            GameType = "Capture the Flag"
        Case "6"
            GameType = "Greed"
        Case "7"
            GameType = "Slaughter"
        Case "8"
            GameType = "Sudden Death"
        Case "9"
            GameType = "Ladder"
        Case "a"
            GameType = "Use Map Settings"
        Case "b"
            GameType = "Team Melee"
        Case "c"
            GameType = "Team Free For All"
        Case "d"
            GameType = "Team Capture the Flag"
        Case "f"
            GameType = "Top vs. Bottom"
        Case "10"
            GameType = "Iron Man Ladder"
        Case Else
            GameType = "Unknowen Game Type (" & strCase & ")"
    End Select
    Exit Function
Erred:
    ErrorHandler "Parse", "GameType"
    Resume Next
End Function
Public Function DecodeMapData(ByVal Encoded As String, ByRef Decoded As String) As Long
Dim enc()  As Byte
Dim dec()  As Byte
Dim I      As Long
Dim J      As Long
Dim D      As Byte
Dim lngLen As Long
    enc = StrConv(Encoded, vbFromUnicode)
    For I = 0 To UBound(enc)
        If (I Mod 8) Then
            ReDim Preserve dec(lngLen)
            dec(lngLen) = (enc(I) And ((RShift(D, 1 + J) Or Not 1)))
            J = J + 1
            lngLen = lngLen + 1
        Else
            J = 0
            D = enc(I)
        End If
    Next I
    Decoded = StrConv(dec, vbUnicode)
    DecodeMapData = lngLen
End Function
Private Function RShift(ByVal pnValue As Long, ByVal pnShift As Long) As Long
    RShift = CLng(pnValue \ (2 ^ pnShift))
End Function
