VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsHyperlink"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Const EM_CHARFROMPOS    As Long = &H427
Private Type Link
    lStart                          As Long
    lSize                           As Long
    sLink                           As String
    bVis                            As Boolean
End Type
Public Enum EventName
    MouseMove
    MouseUp
    MouseDown
End Enum
#If False Then
Private MouseMove, MouseUp, MouseDown
#End If
Private lCurLink                As Long
Private links()                 As Link
Private lNumLinks               As Long
Private Clicked()               As Boolean
Public Sub AddLink(ByVal lStartChar As Long, ByVal sLinkText As String, ByVal sURL As String, ByVal rtb As RichTextBox)
Dim lPrevColor     As Long
Dim bPrevUnderLine As Boolean
    On Error GoTo Erred
    ReDim Preserve links(lNumLinks)
    ReDim Preserve Clicked(lNumLinks)
    lPrevColor = rtb.SelColor
    bPrevUnderLine = rtb.SelUnderline
    rtb.SelUnderline = True
    rtb.SelColor = URLApp.Normal
    rtb.SelText = sLinkText
    rtb.SelColor = lPrevColor
    rtb.SelUnderline = bPrevUnderLine
    links(lNumLinks).lStart = lStartChar
    links(lNumLinks).lSize = Len(sLinkText)
    links(lNumLinks).sLink = sURL
    links(lNumLinks).bVis = False
    Clicked(lNumLinks) = False
    lNumLinks = lNumLinks + 1
Exit Sub
Erred:
    ErrorHandler "Hyperlink", "AddLink"
    Resume Next
End Sub
Public Function HitTest(ByVal x As Long, ByVal Y As Long, ByVal rtb As RichTextBox, ByVal eEventName As EventName, Optional MouseCursor As RichTextLib.MousePointerConstants = rtfDefault) As Boolean
Dim pt   As POINTAPI
Dim lRet As Long
Dim I    As Long
    On Error GoTo Erred
    pt.x = x
    pt.Y = Y
    If lNumLinks < 1 Then
        HitTest = False
        Exit Function
    End If
    lRet = SendMessageA(rtb.hwnd, EM_CHARFROMPOS, 0, pt)
    If eEventName = MouseMove Then
        For I = 0 To lNumLinks - 1
            If lRet >= links(I).lStart And lRet <= links(I).lStart + links(I).lSize - 1 Then
                SetHand
                lCurLink = I
                HitTest = True
                rtb.ToolTipText = links(I).sLink
                Exit For
            Else
                rtb.MousePointer = MouseCursor
                rtb.ToolTipText = vbNullString
            End If
        Next I
    ElseIf eEventName = MouseDown Then
        For I = 0 To lNumLinks - 1
            If lRet >= links(I).lStart And lRet <= links(I).lStart + links(I).lSize - 1 Then
                rtb.SelStart = links(I).lStart
                rtb.SelLength = links(I).lSize
                rtb.SelColor = URLApp.Active
                rtb.SelLength = 0
                Clicked(I) = True
            End If
        Next I
    ElseIf eEventName = MouseUp Then
        For I = 0 To lNumLinks - 1
            If lRet >= links(I).lStart And lRet <= links(I).lStart + links(I).lSize - 1 And Clicked(I) Then
                If HasFocus(frmMain) Then frmMain.txtSend.SetFocus
                OpenURL links(I).sLink
                HitTest = True
                rtb.SelStart = links(I).lStart
                rtb.SelLength = links(I).lSize
                rtb.SelColor = URLApp.Visited
                rtb.SelLength = 0
                links(I).bVis = True
                Exit For
            ElseIf Clicked(I) Then
                If HasFocus(frmMain) Then frmMain.txtSend.SetFocus
                rtb.SelStart = links(I).lStart
                rtb.SelLength = links(I).lSize
                If links(I).bVis Then
                    rtb.SelColor = URLApp.Visited
                Else
                    rtb.SelColor = URLApp.Normal
                End If
                rtb.SelLength = 0
            End If
            Clicked(I) = False
        Next I
    End If
Exit Function
Erred:
    If Err.Number <> 380 Then ErrorHandler "Hyperlink", "HitTest"
    Resume Next
End Function
Public Sub UpdateLinks(ByVal RemovedChars As Long)
Dim I As Integer
Dim J As Long
    On Error GoTo Erred
    If lNumLinks < 1 Then Exit Sub
    For I = 0 To lNumLinks - 1
        links(I).lStart = links(I).lStart - RemovedChars
        If links(I).lStart < 0 Then
            For J = I To lNumLinks - 2
                links(J) = links(J + 1)
                Clicked(J) = Clicked(J + 1)
                links(J).lStart = links(J).lStart - RemovedChars
            Next J
            lNumLinks = lNumLinks - 1
            ReDim Preserve links(lNumLinks)
            Exit For
        End If
    Next I
Exit Sub
Erred:
    ErrorHandler "Hyperlink", "UpdateLinks"
    Resume Next
End Sub
