VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMCI"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit
Private Const MAXPNAMELEN                                  As Integer = 32
Private Const MIXER_LONG_NAME_CHARS                        As Integer = 64
Private Const MIXER_SHORT_NAME_CHARS                       As Integer = 16
Private Type MIXERCONTROLDETAILS_UNSIGNED
    dwValue                                                    As Long
End Type
Private Type MIXERCONTROL
    cbStruct                                                   As Long
    dwControlID                                                As Long
    dwControlType                                              As Long
    fdwControl                                                 As Long
    cMultipleItems                                             As Long
    szShortName                                                As String * MIXER_SHORT_NAME_CHARS
    szName                                                     As String * MIXER_LONG_NAME_CHARS
    lMinimum                                                   As Long
    lMaximum                                                   As Long
    Reserved(10)                                               As Long
End Type
Private Type MIXERCONTROLDETAILS
    cbStruct                                                   As Long
    dwControlID                                                As Long
    cChannels                                                  As Long
    Item                                                       As Long
    cbDetails                                                  As Long
    paDetails                                                  As Long
End Type
Private Type MIXERLINE
    cbStruct                                                   As Long
    dwDestination                                              As Long
    dwSource                                                   As Long
    dwLineID                                                   As Long
    fdwLine                                                    As Long
    dwUser                                                     As Long
    dwComponentType                                            As Long
    cChannels                                                  As Long
    cConnections                                               As Long
    cControls                                                  As Long
    szShortName                                                As String * MIXER_SHORT_NAME_CHARS
    szName                                                     As String * MIXER_LONG_NAME_CHARS
    dwType                                                     As Long
    dwDeviceID                                                 As Long
    wMid                                                       As Integer
    wPid                                                       As Integer
    vDriverVersion                                             As Long
    szPname                                                    As String * MAXPNAMELEN
End Type
Private Type MIXERLINECONTROLS
    cbStruct                                                   As Long
    dwLineID                                                   As Long
    dwControl                                                  As Long
    cControls                                                  As Long
    cbmxctrl                                                   As Long
    pamxctrl                                                   As Long
End Type
Private Const FILE_PREFIX                                  As String = "MCI"
Private Const MMSYSERR_NOERROR                             As Integer = 0
Private Const MIXERLINE_COMPONENTTYPE_DST_FIRST            As Long = &H0
Private Const MIXERLINE_COMPONENTTYPE_SRC_FIRST            As Long = &H1000
Private Const MIXER_GETLINEINFOF_COMPONENTTYPE             As Long = &H3
Private Const MIXER_GETLINECONTROLSF_ONEBYTYPE             As Long = &H2
Private Const MIXER_SETCONTROLDETAILSF_VALUE               As Long = &H0
Private Const MIXERCONTROL_CT_CLASS_FADER                  As Long = &H50000000
Private Const MIXERCONTROL_CT_UNITS_UNSIGNED               As Long = &H30000
Private Const MIXERCONTROL_CONTROLTYPE_FADER               As Double = (MIXERCONTROL_CT_CLASS_FADER Or MIXERCONTROL_CT_UNITS_UNSIGNED)
Private Const MIXERCONTROL_CONTROLTYPE_VOLUME              As Double = (MIXERCONTROL_CONTROLTYPE_FADER + 1)
Private Const MIXERLINE_COMPONENTTYPE_DST_SPEAKERS         As Double = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 4)
Private Const MIXERLINE_COMPONENTTYPE_SRC_SYNTHESIZER      As Double = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 4)
Private Const MIXERLINE_COMPONENTTYPE_DST_WAVEIN           As Double = (MIXERLINE_COMPONENTTYPE_DST_FIRST + 7)
Private Const MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT          As Double = (MIXERLINE_COMPONENTTYPE_SRC_FIRST + 8)
Private strTempPath                                        As String
Private strTempFile                                        As String
Private strDeviceID                                        As String
Private strDevice()                                        As String
Private lngDevices                                         As Long
Private strTemp_File()                                     As String
Private lngTemp_Files                                      As Long
Private strTemp_Info()                                     As String
Private lngTemp_Infos                                      As Long
Private ReturnValue                                        As Long
Private lngLastError                                       As Long
Private boolMCIIsOpen                                      As Boolean
Private boolShutItDown                                     As Boolean
Private VolCtrl_Sys                                        As MIXERCONTROL
Private VolCtrl_Mid                                        As MIXERCONTROL
Private VolCtrl_Wav                                        As MIXERCONTROL
Private VolMin_Sys                                         As Long
Private VolMax_Sys                                         As Long
Private VolMin_Mid                                         As Long
Private VolMax_Mid                                         As Long
Private VolMin_Wav                                         As Long
Private VolMax_Wav                                         As Long
Private hMixer                                             As Long
Private Declare Function GetTempFileNameA Lib "kernel32" (ByVal lpszPath As String, ByVal lpPrefixString As String, ByVal wUnique As Long, ByVal lpTempFileName As String) As Long
Private Declare Function mciSendStringA Lib "winmm.dll" (ByVal lpstrCommand As String, ByVal lpstrReturnString As String, ByVal uReturnLength As Long, ByVal hwndCallback As Long) As Long
Private Declare Function mixerClose Lib "winmm.dll" (ByVal hMixer As Long) As Long
Private Declare Function mixerGetLineControlsA Lib "winmm.dll" (ByVal hMixerObj As Long, pMixerLc As MIXERLINECONTROLS, ByVal fdwControls As Long) As Long
Private Declare Function mixerGetLineInfoA Lib "winmm.dll" (ByVal hMixerObj As Long, pMixerL As MIXERLINE, ByVal fdwInfo As Long) As Long
Private Declare Function mixerOpen Lib "winmm.dll" (ByRef phMixer As Long, ByVal uMxId As Long, ByVal dwCallback As Long, ByVal dwInstance As Long, ByVal fdwOpen As Long) As Long
Private Declare Function mixerSetControlDetails Lib "winmm.dll" (ByVal hMixerObj As Long, pMixerCD As MIXERCONTROLDETAILS, ByVal fdwDetails As Long) As Long
Private Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Private Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
Private Sub Class_Initialize()
Dim ReturnOK As Boolean
    On Error Resume Next
    strDeviceID = "TheDevice"
    lngDevices = lngDevices + 1
    ReDim strDevice(lngDevices) As String
    strDevice(lngDevices) = strDeviceID
    mixerOpen hMixer, 0, 0, 0, 0
    ReturnOK = MCI_VolumeGet(hMixer, MIXERLINE_COMPONENTTYPE_DST_SPEAKERS, MIXERCONTROL_CONTROLTYPE_VOLUME, VolCtrl_Sys)
    If ReturnOK = True Then
        VolMax_Sys = VolCtrl_Sys.lMaximum
        VolMin_Sys = VolCtrl_Sys.lMinimum
    End If
    ReturnOK = False
    ReturnOK = MCI_VolumeGet(hMixer, MIXERLINE_COMPONENTTYPE_SRC_SYNTHESIZER, MIXERCONTROL_CONTROLTYPE_VOLUME, VolCtrl_Mid)
    If ReturnOK = True Then
        VolMax_Mid = VolCtrl_Mid.lMaximum
        VolMin_Mid = VolCtrl_Mid.lMinimum
    End If
    ReturnOK = False
    ReturnOK = MCI_VolumeGet(hMixer, MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT, MIXERCONTROL_CONTROLTYPE_VOLUME, VolCtrl_Wav)
    If ReturnOK = True Then
        VolMax_Wav = VolCtrl_Wav.lMaximum
        VolMin_Wav = VolCtrl_Wav.lMinimum
    End If
End Sub
Private Sub Class_Terminate()
Dim MyCounter As Long
    On Error Resume Next
    boolShutItDown = True
    Close
    For MyCounter = 0 To lngDevices
        If LenB(strDevice(MyCounter)) > 0 Then
            strDeviceID = strDevice(MyCounter)
            MCI_Stop
            MCI_Close
        End If
    Next MyCounter
    CleanUpTempFiles
    mixerClose hMixer
    Erase strDevice
    Erase strTemp_File
    Erase strTemp_Info
End Sub
Private Sub CleanUpTempFiles()
Dim MyCounter As Long
    On Error Resume Next
    If lngTemp_Files = 0 Then
        Exit Sub
    End If
    For MyCounter = 0 To lngTemp_Files
        If LenB(strTemp_File(MyCounter)) > 0 Then
            If LenB(Dir$(strTemp_File(MyCounter))) > 0 Then
                Kill strTemp_File(MyCounter)
            End If
        End If
    Next MyCounter
End Sub
Private Function CreateTempFile(ByVal RES_Type As String, ByVal RES_ID As Long) As String
Dim strThePath As String * 255
Dim strTheFile As String * 255
    On Error Resume Next
    GetTempPathA 255, strThePath
    GetTempFileNameA strThePath, FILE_PREFIX, 0, strTheFile
    strTempPath = Left$(strThePath, InStr(strThePath, ChrW$(0)) - 1)
    strTempFile = Left$(strTheFile, InStr(strTheFile, ChrW$(0)) - 1)
    lngTemp_Files = lngTemp_Files + 1
    lngTemp_Infos = lngTemp_Infos + 1
    ReDim Preserve strTemp_File(lngTemp_Files) As String
    ReDim Preserve strTemp_Info(lngTemp_Infos) As String
    strTemp_File(lngTemp_Files) = strTempFile
    strTemp_Info(lngTemp_Infos) = RES_Type & "|" & CStr(RES_ID)
    CreateTempFile = strTemp_File(lngTemp_Files)
    DoEvents
End Function
Private Sub ErrMsg(ByVal ErrorSource As String, ByVal ErrorNumber As Long, ByVal ErrorDescription As String)
    On Error Resume Next
    If ErrorNumber = 0 Or ErrorNumber = 20 Then
        Exit Sub
    End If
    lngLastError = ErrorNumber
    Err.Clear
End Sub
Public Function ExtractFromRES(RES_Type As String, RES_ID As Long, Optional ByVal FileToExtractTo As String = vbNullString) As Boolean
Dim ResFile() As Byte
Dim nFile     As Long
Dim strTemp   As String
Dim ret       As String
    On Error GoTo ErrorTrap
    If LenB(RES_Type) = 0 Then
        ExtractFromRES = False
        Exit Function
    End If
    ret = SearchForTempFile(RES_Type, RES_ID)
    If LenB(ret) = 0 Then
        If LenB(FileToExtractTo) > 0 Then
            strTemp = FileToExtractTo
        Else
            strTemp = CreateTempFile(RES_Type, RES_ID)
        End If
        GoSub CreateTempFile
    ElseIf LenB(Dir$(ret)) = 0 Then
        If LenB(FileToExtractTo) > 0 Then
            strTemp = FileToExtractTo
        Else
            strTemp = CreateTempFile(RES_Type, RES_ID)
        End If
    Else
        strTempFile = ret
    End If
    ExtractFromRES = True
Exit Function
CreateTempFile:
    ResFile = LoadResData(RES_ID, RES_Type)
    Close
    nFile = FreeFile
    Open strTemp For Binary As #nFile
    Put #nFile, 1, ResFile()
    Close #nFile
    Return
ErrorTrap:
    If Err.Number = 0 Then
        Resume Next
    ElseIf Err.Number = 20 Then
        Resume Next
    Else
        ErrMsg Err.Source, Err.Number, Err.Description
    End If
End Function
Public Function MCI_Close() As Boolean
    On Error GoTo ErrorTrap
    boolMCIIsOpen = False
    ReturnValue = mciSendStringA("close " & strDeviceID, 0&, 0, ByVal 0&)
    If ReturnValue <> 0 And ReturnValue <> 289 And ReturnValue <> 263 And boolShutItDown = False Then
        Exit Function
    End If
    MCI_Close = True
Exit Function
ErrorTrap:
    If Err.Number = 0 Then
        Resume Next
    ElseIf Err.Number = 20 Then
        Resume Next
    Else
        ErrMsg Err.Source, Err.Number, Err.Description
    End If
End Function
Public Property Get MCI_DeviceID() As String
    On Error Resume Next
    MCI_DeviceID = strDeviceID
End Property
Public Property Let MCI_DeviceID(ByVal NewValue As String)
    On Error Resume Next
    If LenB(NewValue) > 0 Then
        strDeviceID = NewValue
        lngDevices = lngDevices + 1
        ReDim Preserve strDevice(lngDevices) As String
        strDevice(lngDevices) = NewValue
    End If
End Property
Public Property Get MCI_LastError() As Long
    On Error Resume Next
    MCI_LastError = lngLastError
End Property
Public Function MCI_PlayMIDI_RES(RES_Type As String, RES_ID As Long) As Boolean
    On Error GoTo ErrorTrap
    If boolMCIIsOpen = True Then
        MCI_Stop
        MCI_Close
        boolMCIIsOpen = False
    End If
    If ExtractFromRES(RES_Type, RES_ID) = False Then
        Exit Function
    End If
    ReturnValue = mciSendStringA("open sequencer!" & strTempFile & " alias " & strDeviceID, 0&, 0, ByVal 0&)
    If ReturnValue <> 0 And ReturnValue <> 289 And ReturnValue <> 263 Then
        Exit Function
    End If
    boolMCIIsOpen = True
    ReturnValue = mciSendStringA("play " & strDeviceID & " notify", 0&, 0, ByVal 0&)
    If ReturnValue <> 0 And ReturnValue <> 289 And ReturnValue <> 263 Then
        Exit Function
    End If
    MCI_PlayMIDI_RES = True
Exit Function
ErrorTrap:
    If Err.Number = 0 Or Err.Number = 20 Then
        Resume Next
    Else
        ErrMsg Err.Source, Err.Number, Err.Description
    End If
End Function
Public Function MCI_PlayWAVE_RES(RES_Type As String, RES_ID As Long) As Boolean
    On Error GoTo ErrorTrap
    If boolMCIIsOpen = True Then
        MCI_Stop
        MCI_Close
        boolMCIIsOpen = False
    End If
    If ExtractFromRES(RES_Type, RES_ID) = False Then
        Exit Function
    End If
    ReturnValue = mciSendStringA("open waveaudio!" & strTempFile & " alias " & strDeviceID, 0&, 0, ByVal 0&)
    If ReturnValue <> 0 And ReturnValue <> 289 And ReturnValue <> 263 Then
        Exit Function
    End If
    boolMCIIsOpen = True
    ReturnValue = mciSendStringA("play " & strDeviceID & " notify", 0&, 0, ByVal 0&)
    If ReturnValue <> 0 And ReturnValue <> 289 And ReturnValue <> 263 Then
        Exit Function
    End If
    MCI_PlayWAVE_RES = True
Exit Function
ErrorTrap:
    If Err.Number = 0 Or Err.Number = 20 Then
        Resume Next
    Else
        ErrMsg Err.Source, Err.Number, Err.Description
    End If
End Function
Public Function MCI_Stop() As Boolean
    On Error GoTo ErrorTrap
    boolMCIIsOpen = False
    ReturnValue = mciSendStringA("stop " & strDeviceID, 0&, 0, ByVal 0&)
    If ReturnValue <> 0 And ReturnValue <> 289 And ReturnValue <> 263 And boolShutItDown = False Then
        Exit Function
    End If
    MCI_Stop = True
Exit Function
ErrorTrap:
    If Err.Number = 0 Then
        Resume Next
    ElseIf Err.Number = 20 Then
        Resume Next
    Else
        ErrMsg Err.Source, Err.Number, Err.Description
    End If
End Function
Private Function MCI_VolumeGet(ByVal hMixer As Long, ByVal ComponentType As Long, ByVal CtrlType As Long, ByRef MxC As MIXERCONTROL) As Boolean
Dim ReturnCode As Long
Dim MxLC       As MIXERLINECONTROLS
Dim MxL        As MIXERLINE
Dim hMem       As Long
    On Error Resume Next
    MxL.cbStruct = Len(MxL)
    MxL.dwComponentType = ComponentType
    ReturnCode = mixerGetLineInfoA(hMixer, MxL, MIXER_GETLINEINFOF_COMPONENTTYPE)
    If ReturnCode = MMSYSERR_NOERROR Then
        MxLC.cbStruct = Len(MxLC)
        MxLC.dwLineID = MxL.dwLineID
        MxLC.dwControl = CtrlType
        MxLC.cControls = 1
        MxLC.cbmxctrl = Len(MxC)
        hMem = GlobalAlloc(&H40, Len(MxC))
        MxLC.pamxctrl = GlobalLock(hMem)
        MxC.cbStruct = Len(MxC)
        ReturnCode = mixerGetLineControlsA(hMixer, MxLC, MIXER_GETLINECONTROLSF_ONEBYTYPE)
        If ReturnCode = MMSYSERR_NOERROR Then
            MCI_VolumeGet = True
            RtlMoveMemory MxC, ByVal MxLC.pamxctrl, Len(MxC)
        Else
            MCI_VolumeGet = False
        End If
        GlobalFree hMem
        Exit Function
    End If
    MCI_VolumeGet = False
End Function
Public Property Let MCI_VolumeMIDI(ByVal NewValue As Long)
    If NewValue > VolMax_Mid Then
        NewValue = VolMax_Sys
    ElseIf NewValue < VolMin_Mid Then
        NewValue = VolMin_Sys
    End If
    MCI_VolumeSet hMixer, VolCtrl_Mid, NewValue
End Property
Public Property Get MCI_VolumeMIDI_Max() As Long
    MCI_VolumeMIDI_Max = VolMax_Mid
End Property
Public Property Get MCI_VolumeMIDI_Min() As Long
    MCI_VolumeMIDI_Min = VolMin_Mid
End Property
Public Property Let MCI_VolumeWAVE(ByVal NewValue As Long)
    If NewValue > VolMax_Wav Then
        NewValue = VolMax_Sys
    ElseIf NewValue < VolMin_Wav Then
        NewValue = VolMin_Sys
    End If
    MCI_VolumeSet hMixer, VolCtrl_Wav, NewValue
End Property
Public Property Get MCI_VolumeWAVE_Max() As Long
    MCI_VolumeWAVE_Max = VolMax_Wav
End Property
Public Property Get MCI_VolumeWAVE_Min() As Long
    MCI_VolumeWAVE_Min = VolMin_Wav
End Property
Private Function MCI_VolumeSet(ByVal hMixer As Long, MxC As MIXERCONTROL, ByVal Volume As Long) As Boolean
Dim ReturnCode As Long
Dim MxCD       As MIXERCONTROLDETAILS
Dim Vol        As MIXERCONTROLDETAILS_UNSIGNED
Dim hMem       As Long
    On Error Resume Next
    MxCD.Item = 0
    MxCD.dwControlID = MxC.dwControlID
    MxCD.cbStruct = Len(MxCD)
    MxCD.cbDetails = Len(Vol)
    hMem = GlobalAlloc(&H40, Len(Vol))
    MxCD.paDetails = GlobalLock(hMem)
    MxCD.cChannels = 1
    Vol.dwValue = Volume
    RtlMoveMemory ByVal MxCD.paDetails, Vol, Len(Vol)
    ReturnCode = mixerSetControlDetails(hMixer, MxCD, MIXER_SETCONTROLDETAILSF_VALUE)
    GlobalFree hMem
    If ReturnCode = MMSYSERR_NOERROR Then
        MCI_VolumeSet = True
    Else
        MCI_VolumeSet = False
    End If
End Function
Public Property Get MCI_VolumeSystem_Max() As Long
    MCI_VolumeSystem_Max = VolMax_Sys
End Property
Public Property Get MCI_VolumeSystem_Min() As Long
    MCI_VolumeSystem_Min = VolMin_Sys
End Property
Private Function SearchForTempFile(ByVal RES_Type As String, ByVal RES_ID As Long) As String
Dim MyCounter  As Long
Dim MyCounter1 As Long
Dim CharRight  As String
Dim TheInfo    As String
Dim TheType    As String
Dim TheID      As String
    On Error Resume Next
    If lngTemp_Infos = 0 Then
        SearchForTempFile = vbNullString
        Exit Function
    Else
        For MyCounter = 0 To lngTemp_Infos
            TheInfo = strTemp_Info(MyCounter)
            If LenB(TheInfo) > 0 Then
                GoSub StripRES_ID
                If TheType = RES_Type And TheID = CStr(RES_ID) Then
                    SearchForTempFile = strTemp_File(MyCounter)
                    Exit Function
                End If
            End If
        Next MyCounter
    End If
Exit Function
StripRES_ID:
    For MyCounter1 = 0 To Len(TheInfo)
        CharRight = Right$(TheInfo, MyCounter1)
        If Left$(CharRight, 1) = "|" Then
            TheID = Right$(CharRight, (Len(CharRight) - 1))
            TheType = Left$(TheInfo, (Len(TheInfo) - Len(CharRight)))
            Return
        End If
    Next MyCounter1
    Return
End Function
