VERSION 5.00
Begin VB.Form frmiTunes 
   BackColor       =   &H00000000&
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "iTunes Control Form"
   ClientHeight    =   240
   ClientLeft      =   45
   ClientTop       =   285
   ClientWidth     =   2310
   BeginProperty Font 
      Name            =   "Arial"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "frmiTunes.frx":0000
   LinkTopic       =   "iTunes"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   240
   ScaleWidth      =   2310
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.Label lblVis 
      Alignment       =   2  'Center
      BackColor       =   &H00000000&
      BackStyle       =   0  'Transparent
      Caption         =   "This form should not be visible."
      ForeColor       =   &H00FFFFFF&
      Height          =   255
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   2295
   End
End
Attribute VB_Name = "frmiTunes"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private WithEvents iTunesAp    As iTunesApp
Attribute iTunesAp.VB_VarHelpID = -1
Private Const NoLoad           As String = "iTunes not loaded."
Private NoCOM                  As Boolean
Public Sub ApplySkin()
    DoEvents
End Sub
Private Sub Form_Load()
    NoCOM = True
    Set iTunesAp = New iTunesApp
    NoCOM = Not (iTunesIsOn)
End Sub
Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    Set iTunesAp = Nothing
    NoCOM = True
    Set frmiTunes = Nothing
End Sub
Private Sub iTunesAp_OnAboutToPromptUserToQuitEvent()
    Set iTunesAp = Nothing
    NoCOM = True
End Sub
Private Sub iTunesAp_OnCOMCallsDisabledEvent(ByVal Reason As iTunesLib.ITCOMDisabledReason)
    NoCOM = True
    Set iTunesAp = Nothing
End Sub
Private Sub iTunesAp_OnCOMCallsEnabledEvent()
    NoCOM = False
    Set iTunesAp = New iTunesApp
End Sub
Private Sub iTunesAp_OnQuittingEvent()
    NoCOM = True
    Set iTunesAp = Nothing
End Sub
Private Sub iTunesAp_OnUserInterfaceEnabledEvent()
    NoCOM = False
End Sub
Public Function iTunesClose() As String
Dim iTunes As iTunesApp
    On Error GoTo Erred
    If Not iTunesIsOn And NoCOM Then
        iTunesClose = NoLoad
        Exit Function
    End If
    Set iTunes = New iTunesApp
    iTunes.Quit
    iTunesClose = "iTunes Closed."
    Set iTunes = Nothing
Exit Function
Erred:
    If Err.Number = 429 Then
        iTunesClose = NoLoad
    Else
        ErrorHandler "iTunes Control", "Close"
    End If
End Function
Public Function iTunesFadeOut() As String
Dim iTunes  As iTunesApp
Dim CurVol  As Integer
Dim RealVol As Integer
    On Error GoTo Erred
    If Not iTunesIsOn And NoCOM Then
        iTunesFadeOut = NoLoad
        Exit Function
    End If
    Set iTunes = New iTunesApp
    CurVol = iTunes.SoundVolume
    RealVol = CurVol
    Do Until CurVol = 0
        CurVol = CurVol - 1
        iTunesSetVolume (CurVol)
        DoEvents
        Sleep 5
    Loop
    iTunesFadeOut = iTunesStop
    iTunesSetVolume (RealVol)
    Set iTunes = Nothing
Exit Function
Erred:
    If Err.Number = 429 Then
        iTunesFadeOut = NoLoad
    Else
        ErrorHandler "iTunes Control", "FadeOut"
    End If
End Function
Public Function iTunesIsOn() As Boolean
    On Error GoTo Erred
    If FindWindowA("iTunes", vbNullString) > 0 Then
        iTunesIsOn = True
    Else
        iTunesIsOn = False
        NoCOM = True
    End If
Exit Function
Erred:
    ErrorHandler "iTunes Control", "iTunesIsOn"
    Resume Next
End Function
Public Function iTunesNext() As String
Dim iTunes As iTunesApp
    On Error GoTo Erred
    If Not iTunesIsOn And NoCOM Then
        iTunesNext = NoLoad
        Exit Function
    End If
    Set iTunes = New iTunesApp
    iTunes.NextTrack
    iTunesNext = "Skipped forward."
    Set iTunes = Nothing
Exit Function
Erred:
    If Err.Number = 429 Then
        iTunesNext = NoLoad
    Else
        ErrorHandler "iTunes Control", "Next"
    End If
End Function
Public Function iTunesPause() As String
Dim iTunes As iTunesApp
    On Error GoTo Erred
    If Not iTunesIsOn And NoCOM Then
        iTunesPause = NoLoad
        Exit Function
    End If
    Set iTunes = New iTunesApp
    If iTunes.PlayerState = 1 Then
        iTunes.PlayPause
        iTunesPause = "Paused."
    End If
    Set iTunes = Nothing
Exit Function
Erred:
    If Err.Number = 429 Then
        iTunesPause = NoLoad
    Else
        ErrorHandler "iTunes Control", "Pause"
    End If
End Function
Public Function iTunesPlay() As String
Dim iTunes As iTunesApp
    On Error GoTo Erred
    If Not iTunesIsOn And NoCOM Then
        iTunesPlay = NoLoad
        Exit Function
    End If
    Set iTunes = New iTunesApp
    Select Case iTunes.PlayerState
    Case 0
        iTunes.PlayPause
        iTunesPlay = "Playing."
    Case 2
        iTunes.Resume
        iTunesPlay = "Playing."
    Case 3
        iTunes.Resume
        iTunesPlay = "Playing."
    End Select
    Set iTunes = Nothing
Exit Function
Erred:
    If Err.Number = 429 Then
        iTunesPlay = NoLoad
    Else
        ErrorHandler "iTunes Control", "Play"
    End If
End Function
Public Function iTunesPlaySong(ByVal strFile As String) As String
Dim iTunes          As iTunesApp
Dim Tracks_SongName As IITTrackCollection
Dim FoundTrack      As IITTrack
    On Error GoTo Erred
    If Not iTunesIsOn And NoCOM Then
        iTunesPlaySong = NoLoad
        Exit Function
    End If
    Set iTunes = New iTunesApp
    If LenB(strFile) > 0 Then
        Set Tracks_SongName = iTunes.LibraryPlaylist.Search(strFile, 5)
    Else
        iTunesPlaySong = "Please enter a song to play."
        Exit Function
    End If
    If Tracks_SongName Is Nothing Then
        iTunesPlaySong = "The song [" & strFile & "] was not found."
        Set FoundTrack = Nothing
        Set Tracks_SongName = Nothing
        Exit Function
    End If
    Set FoundTrack = Nothing
    Set FoundTrack = Tracks_SongName.Item(1)
    If FoundTrack Is Nothing Then
        iTunesPlaySong = "The song [" & strFile & "] was not found."
    Else
        FoundTrack.Play
        iTunesPlaySong = "Playing " & striTunesTitle & "."
    End If
    Set FoundTrack = Nothing
    Set Tracks_SongName = Nothing
    Set iTunes = Nothing
Exit Function
Erred:
    If Err.Number = 429 Or Err.Number = 91 Then
        iTunesPlaySong = NoLoad
    Else
        ErrorHandler "iTunes Control", "PlaySong"
    End If
End Function
Public Function iTunesPrevious() As String
Dim iTunes As iTunesApp
    On Error GoTo Erred
    If Not iTunesIsOn And NoCOM Then
        iTunesPrevious = NoLoad
        Exit Function
    End If
    Set iTunes = New iTunesApp
    iTunes.PreviousTrack
    iTunesPrevious = "Skipped back."
    Set iTunes = Nothing
Exit Function
Erred:
    If Err.Number = 429 Then
        iTunesPrevious = NoLoad
    Else
        ErrorHandler "iTunes Control", "Previous"
    End If
End Function
Public Function iTunesSetVolume(intIndex As Integer) As String
Dim iTunes As iTunesApp
    On Error GoTo Erred
    If Not iTunesIsOn And NoCOM Then
        iTunesSetVolume = NoLoad
        Exit Function
    End If
    Set iTunes = New iTunesApp
    iTunes.SoundVolume = intIndex
    iTunesSetVolume = "Volume set to " & intIndex & "."
    Set iTunes = Nothing
Exit Function
Erred:
    If Err.Number = 429 Then
        iTunesSetVolume = NoLoad
    Else
        ErrorHandler "iTunes Control", "Volume"
    End If
End Function
Public Function iTunesStop() As String
Dim iTunes As iTunesApp
    On Error GoTo Erred
    If Not iTunesIsOn And NoCOM Then
        iTunesStop = NoLoad
        Exit Function
    End If
    Set iTunes = New iTunesApp
    iTunes.Stop
    iTunesStop = "Stopped."
    Set iTunes = Nothing
Exit Function
Erred:
    If Err.Number = 429 Then
        iTunesStop = NoLoad
    Else
        ErrorHandler "iTunes Control", "Stop"
    End If
End Function
Public Function iTunesToggleRandom() As String
Dim iTunes As iTunesApp
    On Error GoTo Erred
    If Not iTunesIsOn And NoCOM Then
        iTunesToggleRandom = NoLoad
        Exit Function
    End If
    Set iTunes = New iTunesApp
    If iTunes.LibraryPlaylist.Shuffle Then
        iTunes.LibraryPlaylist.Shuffle = False
        iTunesToggleRandom = "Playing songs in order."
    Else
        iTunes.LibraryPlaylist.Shuffle = True
        iTunesToggleRandom = "Playing songs randomly."
    End If
    Set iTunes = Nothing
Exit Function
Erred:
    If Err.Number = 429 Then
        iTunesToggleRandom = NoLoad
    Else
        ErrorHandler "iTunes Control", "Random"
    End If
End Function
Public Function iTunesToggleRepeat() As String
Dim iTunes As iTunesApp
    On Error GoTo Erred
    If Not iTunesIsOn And NoCOM Then
        iTunesToggleRepeat = NoLoad
        Exit Function
    End If
    Set iTunes = New iTunesApp
    If iTunes.LibraryPlaylist.SongRepeat = ITPlaylistRepeatModeOff Then
        iTunes.LibraryPlaylist.SongRepeat = ITPlaylistRepeatModeOne
        iTunesToggleRepeat = "Repeating song."
    ElseIf iTunes.LibraryPlaylist.SongRepeat = ITPlaylistRepeatModeOne Then
        iTunes.LibraryPlaylist.SongRepeat = ITPlaylistRepeatModeAll
        iTunesToggleRepeat = "Repeating PlayList."
    Else
        iTunes.LibraryPlaylist.SongRepeat = ITPlaylistRepeatModeOff
        iTunesToggleRepeat = "Repeat disabled."
    End If
    Set iTunes = Nothing
Exit Function
Erred:
    If Err.Number = 429 Then
NoiTunes:
        iTunesToggleRepeat = NoLoad
    Else
        ErrorHandler "iTunes Control", "Repeat"
    End If
End Function
Public Function striTunesTitle() As String
Dim iTunes As iTunesApp
    On Error GoTo Erred
    If Not iTunesIsOn Or NoCOM Then
        striTunesTitle = NoLoad
    Else
        Set iTunes = New iTunesApp
        If LenB(iTunes.CurrentTrack.Artist) > 0 Then
            striTunesTitle = iTunes.CurrentTrack.Artist & " - " & iTunes.CurrentTrack.Name
        Else
            striTunesTitle = iTunes.CurrentTrack.Name
        End If
        Set iTunes = Nothing
    End If
    Exit Function
Erred:
    If Err.Number = 429 Or Err.Number = 91 Then
        If Err.Number = 429 Then striTunesTitle = NoLoad
        If Err.Number = 91 Then striTunesTitle = "Nothing"
    Else
        ErrorHandler "iTunes Control", "Title"
    End If
End Function
